// C Source File
// Created 26/06/03; 14:14:53

// Seven Tiles 0.21 beta

#include "globals.h"

void _main(void)
{
short g,x,y;
short player_coords[4];
void * buffer = NULL;					// buffer for the D-Buffering

INT_HANDLER save_int_1 = GetIntVec (AUTO_INT_1);  // save ints 1,2 and 5
INT_HANDLER save_int_2 = GetIntVec (AUTO_INT_2);
INT_HANDLER save_int_5 = GetIntVec (AUTO_INT_5);

  while(!main_menu())    // loop while the user didn't choose CANCEL at the main menu
  {
    if(!(buffer = malloc(GRAYDBUFFER_SIZE)))  return;  // allocates the buffer for double buffering
    
    SetIntVec(AUTO_INT_1,DUMMY_HANDLER);  // inhibate ints 1,2 and 5
    SetIntVec(AUTO_INT_2,DUMMY_HANDLER);      
    SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
  
    if(!(GrayOn()))
    {
      SetIntVec(AUTO_INT_1,save_int_1);  // restores ints 1,2 and 5
      SetIntVec(AUTO_INT_2,save_int_2);
      SetIntVec(AUTO_INT_5,save_int_5);
      return;
    }

      player_coords[0]=player_coords[1]=player_coords[2]=player_coords[3]=g=x=y=0;
      
      GrayDBufInit(buffer);											// init D-Buffering
      
      FontSetSys (CALCULATOR?F_8x10:F_6x8);			// set font size to medium
      fill_table();          										// fill the table with values from 0 to 6
      
      do
      {
        draw_table(x,y);          // draw all colored tiles with zone separators
        GrayDBufToggleSync();     // D-Buffering

        if(!winner_check()) break;	// exit if someone has won

				if(!(player == PLAYER2 && game_type == PLAYER_VS_AI))					// human player
				{
		      while(!((g=getkey(CALCULATOR))));		// wait for a key   
	        if(K_ENTER)								// if enter (lock or something ...)
	          if(!game_menu())				// switch player if the menu didn't return an escape code
						{
	            player_coords[2*player] = x,player_coords[2*player+1] = y;		// save coords
	            player = (player+1)&1;																				// switch players 
	            
	            if(game_type == PLAYER_VS_PLAYER) 
	            {
	            	x = player_coords[2*player];						// don't switch coords in 1 player game
	            	y = player_coords[2*player+1];	
	            }            	
	          }
	  
	        if(K_LEFT)  x+=7;			// change coords to scroll the grid
	        if(K_RIGHT)	x-=7;
	        if(K_DOWN)  y-=7;
	        if(K_UP)    y+=7;
				}
				else					// play AI
				{
					AI_do();
					player = PLAYER1;			// switch to player 1 (since AI is always player 2)
				}
				
      } while(!K_ESC);
      
      wait_no_key();
  
    GrayOff();      	// return to black & white mode
    free(buffer);			// free the double buffering buffer
    
    SetIntVec(AUTO_INT_1,save_int_1);  // restores ints 1,2 and 5
    SetIntVec(AUTO_INT_2,save_int_2);
    SetIntVec(AUTO_INT_5,save_int_5);
    
    ClrScr();					// clear the screen (and return to the first menu then)
  }
}
